# Witmotion Sensors UART Connection Library
This library implements TTL/UART connections to the inertial pose estimation units (IMUs) manufactured by [WitMotion Shenzhen Co.,Ltd](https://www.wit-motion.com/)

# ROS integration
The main purpose of creation of this library was to provide ROS-compatible integration for Witmotion sensors. Please refer to the following repositories for detailed description. Also, these repositories can be used as a source for coding examples.
- [**ROS1 integration**](https://github.com/ElettraSciComp/witmotion_IMU_ros) ([ROS wiki page](https://wiki.ros.org/witmotion_ros))
- [**ROS2 integration**](https://github.com/ElettraSciComp/witmotion_IMU_ros/tree/ros2)

# Online Autogenerated Documentation
The autogenerated (by Doxygen) documentation of the library can be found on https://elettrascicomp.github.io/witmotion_IMU_QT

# Citation
The release packages of the library are published on [Zenodo](https://zenodo.org). If you use, contribute or base your own work on the library and publish it, it is strongly encouraged to cite the corresponding Zenodo record.

#### Modern BibTeX/Biber
```bibtex
@software{andrei_vukolov_2022_7017118,
  author       = {Vukolov, Andrey},
  title        = {ElettraSciComp/witmotion\_IMU\_QT: Version 0.9.17},
  month        = August,
  year         = 2022,
  publisher    = {Zenodo},
  version      = {v0.9.17-alpha},
  doi          = {10.5281/zenodo.7017118},
  url          = {https://doi.org/10.5281/zenodo.7017118}
}
```

#### Plain BibTeX
```bibtex
@misc{andrei_vukolov_2022_7017118,
  author       = {Vukolov, Andrey},
  title        = {ElettraSciComp/witmotion\_IMU\_QT: Version 0.9.17},
  year         = 2022,
  publisher    = {Zenodo},
  doi          = {10.5281/zenodo.7017118},
  howpublished = {Github Releases \url{https://github.com/ElettraSciComp/witmotion_IMU_QT/releases/tag/v0.9.17-alpha}}
}
```

